/*
 * Copyright 2009, 2010
 *	The President and Fellows of Harvard College.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE UNIVERSITY AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE UNIVERSITY OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stddef.h>

struct pqlcontext;
struct ptstmt;
struct tcexpr;
struct tcstmt;

struct ptstmt *parse(struct pqlcontext *pql, const char *buf, size_t buflen);
struct ptstmt *resolvevars(struct pqlcontext *pql, struct ptstmt *ps);
struct ptstmt *normalize(struct pqlcontext *pql, struct ptstmt *ps);
struct ptstmt *unify(struct pqlcontext *pql, struct ptstmt *ps);
struct ptstmt *movepaths(struct pqlcontext *pql, struct ptstmt *ps);
struct ptstmt *bindnil(struct pqlcontext *pql, struct ptstmt *ps);
struct ptstmt *dequantify(struct pqlcontext *pql, struct ptstmt *ps);

struct tcstmt *tuplify(struct pqlcontext *pql, struct ptstmt *ps);
void typeinf(struct pqlcontext *pql, struct tcstmt *ts);
int typecheck(struct pqlcontext *pql, struct tcstmt *ts);


struct tcexpr *norenames_expr(struct pqlcontext *pql, struct tcexpr *te);

struct tcstmt *norenames(struct pqlcontext *pql, struct tcstmt *ts);
struct tcstmt *unlet(struct pqlcontext *pql, struct tcstmt *ts);
struct tcstmt *baseopt(struct pqlcontext *pql, struct tcstmt *ts);
struct tcstmt *defuse(struct pqlcontext *pql, struct tcstmt *ts);
struct tcstmt *joinorder(struct pqlcontext *pql, struct tcstmt *ts);
struct tcstmt *stepjoins(struct pqlcontext *pql, struct tcstmt *ts);

struct pqlvalue *eval(struct pqlcontext *pql, struct tcstmt *ts);
